<?php

function handleBacktestStart($chat_id, $api_url, $start_url, $request_type, $admin_id, $last_start_file, $wait_file, &$user_data, &$last_start_data) {
    // دیگه اینجا محدودیت زمانی چک نمی‌کنیم
    sendMessage($chat_id, "به بخش بک‌تست خوش آمدید 📊

لطفاً توجه داشته باشید که انتخاب بازه زمانی بیشتر از یک سال امکان‌پذیر نیست. ⏳", $api_url);
    $keyboard = [
        "inline_keyboard" => [[
            ["text" => "2022", "callback_data" => "start_year_2022"],
            ["text" => "2023", "callback_data" => "start_year_2023"],
            ["text" => "2024", "callback_data" => "start_year_2024"]
        ]]
    ];
    $response = sendMessage($chat_id, "سال شروع بکتست 📅:", $api_url, json_encode($keyboard));
    $user_data["step"] = "start_year";
    $user_data["message_id"] = json_decode($response, true)["result"]["message_id"];
    
    $reply_keyboard = [
        "keyboard" => [["بازگشت 🔙"]],
        "resize_keyboard" => true,
        "one_time_keyboard" => false
    ];
    sendMessage($chat_id, "توجه داشته باشید ⚠️
این بخش تنها یک‌بار در روز قابل استفاده است. لطفاً قبل از وارد کردن اطلاعات، دقت کنید.", $api_url, json_encode($reply_keyboard));
}

function handleBacktest($chat_id, $text, $callback_data, $message_id, $api_url, $start_url, $request_type, &$user_data, $wait_file) {
    $admin_id = 6639868796; // آیدی مدیر
    if ($text == "بازگشت") {
        // بازگشت به منوی اصلی
        $keyboard = [
            "keyboard" => [["/start"]],
            "resize_keyboard" => true,
            "one_time_keyboard" => false
        ];
        sendMessage($chat_id, " برای شروع /start ", $api_url, json_encode($keyboard));
        $user_data["step"] = "main_menu";
        unset($user_data["start_year"], $user_data["start_month"], $user_data["start_day"], 
              $user_data["end_year"], $user_data["end_month"], $user_data["end_day"], 
              $user_data["margin"], $user_data["leverage"]);
    } elseif ($callback_data) {
        logDebug("Callback received: $callback_data");
        if (strpos($callback_data, "start_year_") === 0) {
            $year = (int)substr($callback_data, 11);
            $user_data["start_year"] = $year;
            $months = range(1, 12);
            $month_names = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
            $keyboard = ["inline_keyboard" => array_chunk(array_map(fn($m) => ["text" => $month_names[$m-1], "callback_data" => "start_month_$m"], $months), 3)];
            editMessage($chat_id, $user_data["message_id"], "ماه شروع بکتست 📅:", $api_url, json_encode($keyboard));
            $user_data["step"] = "start_month";
        } elseif (strpos($callback_data, "start_month_") === 0) {
            $month = (int)substr($callback_data, 12);
            $user_data["start_month"] = $month;
            $days = range(1, getDaysInMonth($month, $user_data["start_year"]));
            $keyboard = ["inline_keyboard" => array_chunk(array_map(fn($d) => ["text" => "$d", "callback_data" => "start_day_$d"], $days), 5)];
            editMessage($chat_id, $user_data["message_id"], "روز شروع بکتست 📅:", $api_url, json_encode($keyboard));
            $user_data["step"] = "start_day";
        } elseif (strpos($callback_data, "start_day_") === 0) {
            $day = (int)substr($callback_data, 10);
            $user_data["start_day"] = $day;
            $month_names = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
            $month_name = $month_names[$user_data["start_month"] - 1];
            $keyboard = ["inline_keyboard" => [[["text" => "وارد کردن تاریخ پایان بکتست", "callback_data" => "end_date"]]]];
            editMessage($chat_id, $user_data["message_id"], "✅ تاریخ شروع بکتست: {$user_data['start_year']}-$month_name-{$user_data['start_day']}", $api_url, json_encode($keyboard));
            $user_data["step"] = "end_date";
        } elseif ($callback_data == "end_date") {
            $keyboard = [
                "inline_keyboard" => [[
                    ["text" => "2022", "callback_data" => "end_year_2022"],
                    ["text" => "2023", "callback_data" => "end_year_2023"],
                    ["text" => "2024", "callback_data" => "end_year_2024"]
                ]]
            ];
            $response = sendMessage($chat_id, "سال پایان بکتست 📅:", $api_url, json_encode($keyboard));
            $user_data["end_message_id"] = json_decode($response, true)["result"]["message_id"];
            $user_data["step"] = "end_year";
        } elseif (strpos($callback_data, "end_year_") === 0) {
            $year = (int)substr($callback_data, 9);
            $user_data["end_year"] = $year;
            $months = range(1, 12);
            $month_names = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
            $keyboard = ["inline_keyboard" => array_chunk(array_map(fn($m) => ["text" => $month_names[$m-1], "callback_data" => "end_month_$m"], $months), 3)];
            editMessage($chat_id, $user_data["end_message_id"], "ماه پایان بکتست 📅:", $api_url, json_encode($keyboard));
            $user_data["step"] = "end_month";
        } elseif (strpos($callback_data, "end_month_") === 0) {
            $month = (int)substr($callback_data, 10);
            $user_data["end_month"] = $month;
            $days = range(1, getDaysInMonth($month, $user_data["end_year"]));
            $keyboard = ["inline_keyboard" => array_chunk(array_map(fn($d) => ["text" => "$d", "callback_data" => "end_day_$d"], $days), 5)];
            editMessage($chat_id, $user_data["end_message_id"], "روز پایان بکتست 📅:", $api_url, json_encode($keyboard));
            $user_data["step"] = "end_day";
        } elseif (strpos($callback_data, "end_day_") === 0) {
            $day = (int)substr($callback_data, 8);
            $user_data["end_day"] = $day;
            $check = isWithinOneYear($user_data["start_year"], $user_data["start_month"], $user_data["start_day"], $user_data["end_year"], $user_data["end_month"], $day);
            if ($check === "end_before_start") {
                sendMessage($chat_id, "تاریخ پایان نمی‌تواند قبل از تاریخ شروع باشد. لطفاً تاریخ پایان را اصلاح کنید.", $api_url);
            } elseif ($check === "exceeds_one_year") {
                sendMessage($chat_id, "بازه انتخاب‌شده بیشتر از یک سال است. لطفاً بازه یک ساله یا کمتر انتخاب کنید.", $api_url);
            } elseif ($check === true) {
                $month_names = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
                $month_name = $month_names[$user_data["end_month"] - 1];
                $keyboard = ["inline_keyboard" => [[["text" => "وارد کردن مارجین", "callback_data" => "margin"]]]];
                editMessage($chat_id, $user_data["end_message_id"], "✅ تاریخ پایان بکتست: {$user_data['end_year']}-$month_name-{$user_data['end_day']}", $api_url, json_encode($keyboard));
                $user_data["step"] = "margin";
            }
        } elseif ($callback_data == "margin") {
            $response = sendMessage($chat_id, "💰 مارجین بکتست را وارد کنید (حداقل 100):", $api_url);
            $user_data["margin_message_id"] = json_decode($response, true)["result"]["message_id"];
            $user_data["step"] = "enter_margin";
        } elseif ($callback_data == "leverage") {
            $response = sendMessage($chat_id, "لوریج را وارد کنید (مثال 1:500):", $api_url);
            $user_data["leverage_message_id"] = json_decode($response, true)["result"]["message_id"];
            $user_data["step"] = "enter_leverage";
        } elseif ($callback_data == "restart") {
            $keyboard = [
                "inline_keyboard" => [[
                    ["text" => "2022", "callback_data" => "start_year_2022"],
                    ["text" => "2023", "callback_data" => "start_year_2023"],
                    ["text" => "2024", "callback_data" => "start_year_2024"]
                ]]
            ];
            $response = sendMessage($chat_id, "سال شروع بکتست 📅:", $api_url, json_encode($keyboard));
            $user_data["message_id"] = json_decode($response, true)["result"]["message_id"];
            $user_data["step"] = "start_year";
            unset($user_data["start_year"], $user_data["start_month"], $user_data["start_day"], 
                  $user_data["end_year"], $user_data["end_month"], $user_data["end_day"], 
                  $user_data["margin"], $user_data["leverage"]);
        } elseif ($callback_data == "start_backtest") {
            $current_time = time();
            $last_start_file = 'path/to/last_start.json'; // مسیر فایل ذخیره‌سازی (باید با مسیر واقعی جایگزین بشه)
            $last_start_data = file_exists($last_start_file) ? json_decode(file_get_contents($last_start_file), true) : [];
            if (!is_array($last_start_data)) $last_start_data = [];
            $last_start_time = $last_start_data[$chat_id] ?? 0;
            $time_diff = $current_time - $last_start_time;

            if ($chat_id != $admin_id && $time_diff < 24 * 60 * 60) {
                // کاربر عادی و کمتر از ۲۴ ساعت گذشته
                $remaining_seconds = (24 * 60 * 60) - $time_diff;
                $remaining_hours = floor($remaining_seconds / 3600);
                $remaining_minutes = floor(($remaining_seconds % 3600) / 60);
                sendMessage($chat_id, "شما فقط هر ۲۴ ساعت یک‌بار می‌توانید بک‌تست را شروع کنید.\nزمان باقی‌مانده: $remaining_hours ساعت و $remaining_minutes دقیقه", $api_url);
            } else {
                // مدیر یا کاربر عادی که ۲۴ ساعت گذشته
                $month_names = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
                $start_month_name = $month_names[$user_data["start_month"] - 1];
                $end_month_name = $month_names[$user_data["end_month"] - 1];
                $final_text = "تاریخ شروع: {$user_data['start_year']}-{$user_data['start_month']}-{$user_data['start_day']}\nتاریخ پایان: {$user_data['end_year']}-{$user_data['end_month']}-{$user_data['end_day']}\n💰مارجین وارد شده  : {$user_data['margin']}\nلوریج: {$user_data['leverage']}\n⏳ در حال پردازش...";
                editMessage($chat_id, $user_data["final_message_id"], $final_text, $api_url);
                $data = [
                    "start_year" => $user_data["start_year"],
                    "start_month" => $user_data["start_month"],
                    "start_day" => $user_data["start_day"],
                    "end_year" => $user_data["end_year"],
                    "end_month" => $user_data["end_month"],
                    "end_day" => $user_data["end_day"],
                    "margin" => $user_data["margin"],
                    "leverage" => $user_data["leverage"]
                ];
                $result = sendStartRequest($chat_id, $start_url, $request_type, $data);
                if ($result["response"] == "start") {
                    sendMessage($chat_id, "✅ درخواست شما شروع شد!
و تا دقایقی دیگر فایل بک تست برای شما ارسال خواهد شد", $api_url);
                } elseif ($result["response"] == "wait") {
                    sendMessage($chat_id, "⏳ لطفاً منتظر بمانید...
تا دقایقی دیگر فایل بک تست برای شما ارسال خواهد شد ", $api_url);
                    $wait_list = file_exists($wait_file) ? json_decode(file_get_contents($wait_file), true) : [];
                    if (!is_array($wait_list)) $wait_list = [];
                    $wait_list[] = array_merge(["user_id" => $chat_id, "request_type" => $request_type, "status" => "wait"], $data);
                    $data_folder = dirname($wait_file);
                    if (!is_dir($data_folder)) mkdir($data_folder, 0777, true);
                    file_put_contents($wait_file, json_encode($wait_list, JSON_PRETTY_PRINT));
                }
                // ذخیره زمان فعلی برای این کاربر
                $last_start_data[$chat_id] = $current_time;
                $data_folder = dirname($last_start_file);
                if (!is_dir($data_folder)) mkdir($data_folder, 0777, true);
                file_put_contents($last_start_file, json_encode($last_start_data, JSON_PRETTY_PRINT));
                $user_data["step"] = "done";
            }
        }
    } elseif ($text && isset($user_data["step"])) {
        if ($user_data["step"] == "enter_margin") {
            if (is_numeric($text) && $text >= 100 && $text <= 1000000) {
                $user_data["margin"] = $text;
                editMessage($chat_id, $user_data["margin_message_id"], "💰مارجین وارد شده  : $text", $api_url);
                $keyboard = ["inline_keyboard" => [[["text" => "وارد کردن لوریج", "callback_data" => "leverage"]]]];
                $response = sendMessage($chat_id, "لوریج را وارد کنید (مثال 1:500):", $api_url, json_encode($keyboard));
                $user_data["leverage_message_id"] = json_decode($response, true)["result"]["message_id"];
                $user_data["step"] = "leverage";
            } else {
                sendMessage($chat_id, "بازه وارد کردن مارجین: 100 تا 1000000", $api_url);
            }
        } elseif ($user_data["step"] == "enter_leverage") {
            if (preg_match("/^1:(\d+)$/", $text, $matches) && $matches[1] >= 100 && $matches[1] <= 3000) {
                $user_data["leverage"] = $text;
                $keyboard = [
                    "inline_keyboard" => [
                        [["text" => "وارد کردن مجدد", "callback_data" => "restart"]],
                        [["text" => "شروع بکتست", "callback_data" => "start_backtest"]]
                    ]
                ];
                $response = sendMessage($chat_id, "⏰تاریخ شروع: {$user_data['start_year']}-{$user_data['start_month']}-{$user_data['start_day']}\n📅تاریخ پایان: {$user_data['end_year']}-{$user_data['end_month']}-{$user_data['end_day']}\n💰مارجین وارد شده  : {$user_data['margin']}\n⚖️لوریج وارد شده : $text", $api_url, json_encode($keyboard));
                $user_data["final_message_id"] = json_decode($response, true)["result"]["message_id"];
                $user_data["step"] = "final";
            } else {
                sendMessage($chat_id, "بازه وارد کردن لوریج:(مثال 1:500)", $api_url);
            }
        }
    }
}

?>